<?php
// $Author$
// $Id$

$iworx_ini = parse_ini_file( '/usr/local/interworx/lib/squirrelmail/iworx.ini', true );
$dsn = $iworx_ini['vpopmail.spam']['dsn'];

global $SqlDSN, $SqlTable, $use_quick_link, $sasql_use_learn, $columns;
// DSN for DB
$SqlDSN = $dsn;

// SpamAssassin userprefs table
$SqlTable = 'userpref';

// Table columns.
// The defaults should work for most plain vanilla SpamAssassin
// installations. Some people, however, use different column names and
// custom selects. This allows those special people to change the columns
// easily here.
$columns = array();
$columns['username'] = 'username';     # SA expects 'username'
$columns['preference'] = 'preference'; # SA expects 'preference'
$columns['value'] = 'value';           # SA expects 'value'
$columns['id'] = 'prefid';             # SA expects 'prefid'

// DSN for DB
// SpamAssassin allows you to use a different DB for bayes
// You can make this the same as the userpref DB by doing
// $SABayesDSN = $SqlDSN;
// This is only used by the bayes_stats section which is not
// enabled by default.
$SABayesDSN = 'mysql://<user>:<pass>@<host>/<db>';

// SpamAssassin bayes_vars table
$SABayesVarsTable = 'bayes_vars';

// bayes_vars table columns
// The defaults should be fine for most people.
$bayes_vars_cols = array();
$bayes_vars_cols['username'] = 'username';     # SA expects 'username'
$bayes_vars_cols['spam_count'] = 'spam_count'; # SA expects 'spam_count'
$bayes_vars_cols['ham_count'] = 'ham_count';   # SA expects 'ham_count'

// Default domain
// Set to your domain to have the domain appended to usernames
// when working with the database. Set to '' or comment out to
// disable. Note: If you are using multiple domains, the vlogin plugin
// may work better. Actually, the vlogin plugin may work better in
// general. However, this it a resonable workaround if your mail server
// doesn't allow you to login as user@domain but you need to use the
// domain in the SpamAssassin settings.
//$default_domain = 'example.com';

// Make the $spam_folder below, a special folder.
// If set to some true value, the spam folder will be auto created.
// If you wish to make use of the Purge Spam Folder button, then this will
// need to be set to 1
$special_spam_folder = 1;

// The name of the spam folder. Do not include the prefix if it is already
// defined in the Squirrel Mail config already, i.e. if you have set
// $default_folder_prefix in your config.php then set this variable
// to be 'Spam'. If you don't have $default_folder_prefix set globally
// and your IMAP server does have a require folder prefix, then you
// may need to define this variable as 'INBOX.Spam'.
$spam_folder = 'Spam';

// Add a link to the Options line in message header view to add/delete a
// message address to the white/black list.
$use_quick_link = True;

// If you plan on using the process-spam.pl script or your own home grown
// version, then setting this to True will allow the storage of emails
// on your server for later processing through sa_learn.
$sasql_use_learn = True;

// If set to True, then the option to learn the message as spam will be
// a link in the options line, otherwise it will be a button at the bottom
// of the message. Note: This has no effect if $sasql_use_learn is False.
$sasql_learn_option = True;

// Set to '' to disable.
// The included process-spam.pl script provides a way to learn messages
// moved into these folders.
$learn_spam_folder = 'Learn Spam';
$learn_fp_folder = 'Learn Ham';

// Show a spam report in the message headers.
// This will only show something if the 'X-Spam-Status' header
// is present in the message.
// This option only works with SM 1.4.9 or with the patch at
// https://sourceforge.net/tracker/?func=detail&aid=1589520&group_id=311&atid=300311
$show_spam_report = True;

// Show the message's score in the spam report.
// $show_spam_report must also be set.
$show_report_score = False;

// Use SpamAssassin 2.43 options
// SpamAssassin removed the 'report_header' and 'defang_mime' flags
// from version 2.50 because of better MIME spam handling.
// You can include those options by setting this to some True value.
//
// Note: This option is depricated in favor of the $allowed_params
// list. It is here to for backwards compatability with
// sasql_options-1.1.5.php.
//$useSA2_43 = True;
$useSA2_43 = False;

// Global settings username key used to define system-wide preferences
//
//$globalUsername = '!GLOBAL';
$globalUsername = '@GLOBAL';

// Allowed SpamAssassin paramaters.
// These values must be defined in $sa_params below.
// Currently defined values: 'required_hits', 'rewrite_subject',
//   'use_terse_report', 'use_dcc', 'use_razor1', 'use_razor2',
//   'always_add_headers', 'subject_tag', 'ok_languages'
// See sa_opts-dist.php for a complete list of supported parameters.

//$allowed_params = array('required_hits', 'rewrite_subject', 'subject_tag',
//			'use_terse_report', 'use_dcc', 'use_razor2',
//			'always_add_headers', 'ok_languages');

$allowed_params = array('required_score', 'rewrite_header subject',
			'ok_languages', 'use_dcc', 'use_razor2'
			);

$allowed_wl_params = array('whitelist_from', 'unwhitelist_from',
			   'blacklist_from', 'unblacklist_from',
			   'whitelist_to');

// Sections to show.
// This will insert the file $section.inc.php into sasql_options.php
// where $section is the an element from $allowed_sections. You can use this
// to add custom sections to your installation or reorder sections to match
// your tastes.
//  Sections:
//   General Sections:
//    purge         => Purge Spam Folder Button
//
//   SpamAssassin Sections:
//    sa_abooksync  => Sync Address Book with Whitelist
//    sa_whitelist  => Manage SA White/blacklists
//    sa_settings   => Manage SA settings
//    bayes_stats   => Display the number of messages learned as Ham or Spam
//   Note: sa_abooksync needs to be before sa_whitelist or changes won't be
//   immediately visable.
//
//   dspam Sections:
//    dspam         => opt-in/out of dpam
//    dspam_primer  => A brief description of dspam and comparison to SA
//
//   policyd Sections:
//    policyd       => Allows users to opt-in/out of greylisting in policyd
//    policyd_docs  => User documentation for policyd options.
//
//   Section tools to make combining sections in to blocks.
//   NOTE: The first start_section and last end_section are done for you.
//    start_section => Start a new section block.
//    end_section   => End a Section block
//    divider       => shortcut for the common end_section, start_section case.
$allowed_sections = array ('purge',
			   'divider',
			   'sa_abooksync', 'sa_whitelist',
			   'divider',
			   'sa_settings');

// Only add these if $useSA2_43 is true.
if ($useSA2_43)
{
  array_push($allowed_params, 'report_header', 'defang_mime');
}

// SpamAssassin params
$sa_params = array();
$wl_params = array();

include_once('sa_opts-dist.php');	// Bring in SA options
if (file_exists('sa_opts.php')) {
  include_once('sa_opts.php');
}

?>