<?php 

/*    See README for details and credits and the like.

***************************************************************************************************/


function Decode_Chunked_Message ($message) 
{
/*	
 *  Apply this function after http response ($message) is fully received. 
 *  It does not guarantee that all data is received from the network.
 *  You can use $DEBUG = True; to see each chunk decoded with info
 *	
 *  $DEBUG = True;
 *
 *  CHUNKED MESSAGES ARE FORMATTED LIKE THIS (Extension Not Supported)
 *  HEXA_CHUNK_SIZE | CRLF | DATA | HEXA_CHUNK_SIZE | CRLF | HEXA_CHUNK_SIZE |CRLF | DATA |HEXA_CHUNKSIZE | ... | 0
 *  (0 means next CHUNK SIZE = 0 indicating the end of the chunk encoded message)
 *  pipes don't actually appear in the original chunked message stream (they just included here for your eyes ...)
 *  Can't quite remember where I found the basic framework for this function.  But I had to significantly
 *  modify it.  So my applogies to the unattributed.  Try search PHP.net--I think it is there.
 *
 */
	global $debug;
	$CRLF_LENGTH = 2;
	$chunk_pos = 0;
	$crlf_pos = strpos ($message , "\r\n\r\n" , $chunk_pos);
	$chunk_msg = strstr ($message, "\r\n\r\n" );
	$chunk_msg = substr ($chunk_msg, 4); 
	$chunk_size = substr ($chunk_msg, 0, strpos ($chunk_msg, "\r\n"));
	$chunk_msg = substr ($chunk_msg, strpos ($chunk_msg, "\r\n")+2);
	
	$octets_to_read = hexdec ( $chunk_size );
	
	if ( isset($debug) && $debug === TRUE ) 
	{
		$myfp = fopen ("/tmp/twc_weather-chunk_debug.log", "w");
	}
	$buffer = '';
	while ( $octets_to_read > 0 ) 
        {
		if ($debug) 
                {
			fwrite ($myfp, "octets_to_read : $octets_to_read ( $chunk_size )\n");
			fwrite ($myfp, "new chunk_msg : " . substr ($chunk_msg, 0, $octets_to_read + 2) . "\n\n");
		}

		$buffer .= substr ( $chunk_msg, 0, $octets_to_read );

		$chunk_msg = substr ( $chunk_msg, $octets_to_read + $CRLF_LENGTH);
		$chunk_size = substr ($chunk_msg, 0, strpos ($chunk_msg, "\r\n"));
		$chunk_msg = substr ($chunk_msg, strlen($chunk_size) + $CRLF_LENGTH);
		$octets_to_read = hexdec($chunk_size);
	}
	if ( isset ($debug) && $debug === TRUE )
	{
		fclose ($myfp);
	}
	return $buffer;
}

?>
